/* eslint-disable prettier/prettier */
<template>
  <div class="container">
    <h2 class="title">產品列表</h2>

    <div class="row">
      <div class="container">
        <table class="table">
          <thead class="col-12">
            <th>產品名稱</th>
            <th>產品標題</th>
            <th>產品材質</th>
            <th>產品規格</th>
            <th>口罩顏色</th>
            <th>口罩用途</th>
            <th>適用情況</th>
            <th>保存期限</th>
            <th>盒裝數量</th>
            <th>保存方式</th>
            <th>介紹</th>
          </thead>
        </table>
      </div>
    </div>
    <div class="row" v-for="(a, b) in product" :key="b">
      <div class="container">
        <table class="table">
          <tbody class="col-12">
            <tr v-if="editId !== a[0].product_id">
              <td>{{ a[0].productName }}</td>
              <td>{{ a[0].title }}</td>
              <td>{{ a[0].material }}</td>
              <td>{{ a[0].spec }}</td>
              <td>{{ a[0].color }}</td>
              <td>{{ a[0].used }}</td>
              <td>{{ a[0].situation }}</td>
              <td>{{ a[0].dueday }}</td>
              <td>{{ a[0].quantity }}</td>
              <td>{{ a[0].storageMethod }}</td>
              <td>{{ a[0].info }}</td>
            </tr>
            <tr v-if="editId === a[0].product_id">
              <td><input class="col-12" v-model="editData.productName" /></td>
              <td><input class="col-12" v-model="editData.title" /></td>
              <td><input class="col-12" v-model="editData.material" /></td>
              <td><input class="col-12" v-model="editData.spec" /></td>
              <td>
                <input class="col-12" v-model="editData.color" value="" />
              </td>
              <td><input class="col-12" v-model="editData.used" /></td>
              <td><input class="col-12" v-model="editData.situation" /></td>
              <td><input class="col-12" v-model="editData.dueday" /></td>
              <td><input class="col-12" v-model="editData.quantity" /></td>
              <td><input class="col-12" v-model="editData.storageMethod" /></td>
              <td><input class="col-12" v-model="editData.info" /></td>
            </tr>
          </tbody>
        </table>
        <button
          class="btn btn-info"
          style="background-color: #0dcaf0"
          @click="showImg(a[0].product_id, a.img)"
          type="button"
        >
          圖片列表
        </button>
        <button
          class="btn btn-success"
          style="background-color: #198754"
          type="button"
          v-if="editId !== a[0].product_id"
          @click="edit(a[0])"
        >
          編輯
        </button>
        <button
          class="btn btn-primary"
          type="button"
          v-if="editId === a[0].product_id"
          @click="save(a)"
        >
          儲存
        </button>
        <button
          class="btn btn-light"
          style="color: #000; background-color: #f8f9fa"
          type="button"
          v-if="editId === a[0].product_id"
          @click="cancel"
        >
          取消
        </button>
        <button
          class="btn btn-danger"
          style="background-color: #dc3545"
          type="button"
          @click="delAll(a[0].product_id)"
        >
          刪除
        </button>
        <div v-if="isShowImg === a[0].product_id" class="col-12">
          <div class="form-group">
            <label>圖片上傳</label>
            <div>
              <input
                type="file"
                class="form-control img-upload"
                ref="file"
                multiple
                @change="onFileChange"
              />
              <div v-if="preview_list.length" class="img-list">
                <div v-for="(item, index) in preview_list" :key="index">
                  <img :src="item" />
                </div>

                <button @click="uploadImg(a[0].product_id)">上傳</button>
              </div>
            </div>
          </div>
          <div v-for="(i, k) in imgList" :key="k">
            <div v-for="(x,y) in i" :key="y">
              <img :src="x" alt="" />
              <button
                class="btn btn-danger"
                style="background-color: #dc3545"
                type="button"
                @click="delImg(a[0].product_id, x)"
              >
                刪除
              </button>
            </div>
          </div>
          <loading
            :active.sync="isLoading"
            :can-cancel="true"
            :is-full-page="true"
          />
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import {
  getProductList,
  getProductDetail,
  apiDeleteAll,
  apiDeleteImg,
  apiEdit,
  apiUploadImg,
  apiProductsList,
  apiProductsDetail,
} from "@/api/api.js";

import Loading from "vue-loading-overlay";
import "vue-loading-overlay/dist/vue-loading.css";
import { constants } from "crypto";

export default {
  name: "AllList",
  data() {
    return {
      product: [],
      proudctName: "",
      editId: "",
      editData: {},
      formData: new FormData(),
      isShowImg: "",
      isLoading: false,
      imgList: [],
      images: [],
      preview_list: [],
      info: "",
    };
  },

  components: {
    Loading,
  },
  mounted() {
    this.getList();
  },
  methods: {
    async getList() {
      let res = await apiProductsList();
      let data = res.data.data;
      for (const [key, value] of Object.entries(data.data)) {
        let tmp = Object.entries(value);

        if (tmp.length === 0) delete data.data[key];
      }

      this.product = data.data;
    },
    async showImg(id, item) {
      this.isLoading = true;
      this.imgList = [];
      this.isShowImg = id;
      this.imgList = item;
      this.isLoading = false;
    },
    async delAll(product_id) {
      let r = confirm("確定要刪除嗎");
      if (r == true) {
        let res = await apiDeleteAll({ product_id });
        this.getList();
      }
    },
    edit(item) {
      this.editId = item.product_id;
      this.editData = Object.assign({}, item);
    },
    cancel() {
      this.editId = 0;
    },
    onFileChange(e) {
      let selectedFile = e.target.files;

      if (!selectedFile.length) {
        return false;
      }

      for (let i = 0; i < selectedFile.length; i++) {
        var reader = new FileReader();
        reader.onload = (e) => {
          this.preview_list.push(e.target.result);
        };
        this.images.push(selectedFile[i]);
        reader.readAsDataURL(selectedFile[i]);
      }
    },
    async uploadImg(product_id) {
      console.log("prodcut_id:" + product_id);
      this.formData.append("product_id", product_id);

      const config = {
        headers: { "content-type": "multipart/form-data" },
      };

      let formData = new FormData();
      for (let i = 0; i < this.images.length; i++) {
        let file = this.images[i];
        formData.append("images[" + i + "]", file);
      }

      formData.append("product_id", product_id);
      this.isLoading = true;
      let res = await apiUploadImg(formData);
      if (res) {
        this.isLoading = false;
        this.preview_list = [];
        this.images = Array.from([]);
        this.isShowImg = "";
      }
    },
    async save() {
      let res = await apiEdit(this.editData);
      this.getList();
      this.editId = "";
      this.editData = Object.assign({});
    },
    async delImg(product_id, url) {
      let r = confirm("確定要刪除嗎");
      if (r == true) {
        console.log(url);
        let res = await apiDeleteImg({ product_id, url });
        this.imgList = [];
        this.isShowImg = "";
      }
    },
    del() {},
  },
  computed: {
    productName: function (newValue, oldValue) {
      console.log(newValue, oldValue);
    },
  },
};
</script>
